// python wrapper for vtkOpenGLHAVSVolumeMapper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOpenGLHAVSVolumeMapper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLHAVSVolumeMapper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLHAVSVolumeMapper_ClassNew(); }

#ifndef DECLARED_PyvtkHAVSVolumeMapper_ClassNew
extern "C" { PyObject *PyvtkHAVSVolumeMapper_ClassNew(); }
#define DECLARED_PyvtkHAVSVolumeMapper_ClassNew
#endif

static const char **PyvtkOpenGLHAVSVolumeMapper_Doc();


static PyObject *
PyvtkOpenGLHAVSVolumeMapper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOpenGLHAVSVolumeMapper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHAVSVolumeMapper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHAVSVolumeMapper *op = static_cast<vtkOpenGLHAVSVolumeMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLHAVSVolumeMapper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHAVSVolumeMapper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOpenGLHAVSVolumeMapper *tempr = vtkOpenGLHAVSVolumeMapper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHAVSVolumeMapper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHAVSVolumeMapper *op = static_cast<vtkOpenGLHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLHAVSVolumeMapper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLHAVSVolumeMapper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHAVSVolumeMapper_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHAVSVolumeMapper *op = static_cast<vtkOpenGLHAVSVolumeMapper *>(vp);

  vtkRenderer *temp0 = NULL;
  vtkVolume *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkRenderer") &&
      ap.GetVTKObject(temp1, "vtkVolume"))
  {
    if (ap.IsBound())
    {
      op->Render(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLHAVSVolumeMapper::Render(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHAVSVolumeMapper_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHAVSVolumeMapper *op = static_cast<vtkOpenGLHAVSVolumeMapper *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkOpenGLHAVSVolumeMapper::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHAVSVolumeMapper_SetGPUDataStructures(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGPUDataStructures");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHAVSVolumeMapper *op = static_cast<vtkOpenGLHAVSVolumeMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGPUDataStructures(temp0);
    }
    else
    {
      op->vtkOpenGLHAVSVolumeMapper::SetGPUDataStructures(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHAVSVolumeMapper_SupportedByHardware(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SupportedByHardware");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHAVSVolumeMapper *op = static_cast<vtkOpenGLHAVSVolumeMapper *>(vp);

  vtkRenderer *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
  {
    bool tempr = (ap.IsBound() ?
      op->SupportedByHardware(temp0) :
      op->vtkOpenGLHAVSVolumeMapper::SupportedByHardware(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLHAVSVolumeMapper_Methods[] = {
  {"IsTypeOf", PyvtkOpenGLHAVSVolumeMapper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkOpenGLHAVSVolumeMapper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkOpenGLHAVSVolumeMapper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkOpenGLHAVSVolumeMapper\nC++: static vtkOpenGLHAVSVolumeMapper *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOpenGLHAVSVolumeMapper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLHAVSVolumeMapper\nC++: vtkOpenGLHAVSVolumeMapper *NewInstance()\n\n"},
  {"Render", PyvtkOpenGLHAVSVolumeMapper_Render, METH_VARARGS,
   "V.Render(vtkRenderer, vtkVolume)\nC++: void Render(vtkRenderer *ren, vtkVolume *vol)\n\nRender the volume\n"},
  {"ReleaseGraphicsResources", PyvtkOpenGLHAVSVolumeMapper_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *)\n\nRelease any graphics resources that are being consumed by this\nvolume renderer.\n"},
  {"SetGPUDataStructures", PyvtkOpenGLHAVSVolumeMapper_SetGPUDataStructures, METH_VARARGS,
   "V.SetGPUDataStructures(bool)\nC++: void SetGPUDataStructures(bool)\n\nSet/get whether or not the data structures should be stored on\nthe GPU for better peformance.\n"},
  {"SupportedByHardware", PyvtkOpenGLHAVSVolumeMapper_SupportedByHardware, METH_VARARGS,
   "V.SupportedByHardware(vtkRenderer) -> bool\nC++: bool SupportedByHardware(vtkRenderer *r)\n\nCheck hardware support for the HAVS algorithm.  Necessary\nfeatures include off-screen rendering, 32-bit fp textures,\nmultiple render targets, and framebuffer objects. Subclasses must\noverride this method to indicate if supported by Hardware.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLHAVSVolumeMapper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumeOpenGLPython.vtkOpenGLHAVSVolumeMapper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLHAVSVolumeMapper_StaticNew()
{
  return vtkOpenGLHAVSVolumeMapper::New();
}

PyObject *PyvtkOpenGLHAVSVolumeMapper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLHAVSVolumeMapper_Type, PyvtkOpenGLHAVSVolumeMapper_Methods,
    "vtkOpenGLHAVSVolumeMapper",
    PyvtkOpenGLHAVSVolumeMapper_Doc(), &PyvtkOpenGLHAVSVolumeMapper_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLHAVSVolumeMapper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkHAVSVolumeMapper_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLHAVSVolumeMapper_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLHAVSVolumeMapper - Hardware-Assisted\n\n",
    "Superclass: vtkHAVSVolumeMapper\n\n",
    "Visibility Sorting unstructured grid mapper, OpenGL implementation\n\nvtkHAVSVolumeMapper is a class that renders polygonal data\n(represented as an unstructured grid) using the Hardware-Assisted\nVisibility Sorting (HAVS) algorithm.  First the unique triangles are\nsorted in object space, then they are sorted in image space using a\nfixed size A-buffer implemented on the GPU called the k-buffer.  The\nH",
    "AVS algorithm excels at rendering large datasets quickly.  The\ntrade-off is that the algorithm may produce some rendering artifacts\ndue to an insufficient k size (currently 2 or 6 is supported) or\nread/write race conditions.\n\nA built in level-of-detail (LOD) approach samples the geometry using\none of two heuristics (field or area).  If LOD is enabled, the amount\nof geometry that is sampled and ren",
    "dered changes dynamically to stay\nwithin the target frame rate.  The field sampling method generally\nworks best for datasets with cell sizes that don't vary much in size.\n On the contrary, the area sampling approach gives better\napproximations when the volume has a lot of variation in cell size.\n\nThe HAVS algorithm uses several advanced features on graphics\nhardware. The k-buffer sorting network i",
    "s implemented using\nframebuffer objects (FBOs) with multiple render targets (MRTs). \nTherefore, only cards that support these features can run the\nalgorithm (at least an ATI 9500 or an NVidia NV40 (6600)).\n\n@attention Several issues had to be addressed to get the HAVS\nalgorithm working within the vtk framework.  These additions forced\nthe code to forsake speed for the sake of compliance and robust",
    "ness.\n\n@attention The HAVS algorithm operates on the triangles that compose\nthe mesh. Therefore, before rendering, the cells are decomposed into\nunique triangles and stored on the GPU for efficient rendering.  The\nuse of GPU data structures is only recommended if the entire geometry\ncan fit in graphics memory.  Otherwise this feature should be\ndisabled.\n\n@attention Another new feature is the handl",
    "ing of mixed data types\n(eg., polygonal data with volume data).  This is handled by reading\nthe z-buffer from the current window and copying it into the\nframebuffer object for off-screen rendering.  The depth test is then\nenabled so that the volume only appears over the opaque geometry. \nFinally, the results of the off-screen rendering are blended into the\nframebuffer as a transparent, view-aligne",
    "d texture.\n\n@attention Instead of using a preintegrated 3D lookup table for\nstoring the ray integral, this implementation uses partial\npre-integration.  This improves the performance of dynamic transfer\nfunction updates by avoiding a costly preprocess of the table.\n\n@attention A final change to the original algorithm is the handling\nof non-convexities in the mesh.  Due to read/write hazards that m",
    "ay\ncreate undesired artifacts with non-convexities when using a\ninside/outside toggle in the fragment program, another approach was\nemployed.  To handle non-convexities, the fragment shader determines\nif a ray-gap is larger than the max cell size and kill the fragment\nif so.  This approximation performs rather well in practice but may\nmiss small non-convexities.\n\n@attention For more information on",
    " the HAVS algorithm see:\n\n@attention\n \"Hardware-Assisted Visibility Sorting for Unstructured Volume\nRendering\" by S. P. Callahan, M. Ikits, J. L. D. Comba, and C. T.\nSilva, IEEE Transactions of Visualization and Computer Graphics;\nMay/June 2005.\n\n@attention For more information on the Level-of-Detail algorithm,\nsee:\n\n@attention \"Interactive Rendering of Large Unstructured Grids Using\nDynamic Level",
    "-of-Detail\" by S. P. Callahan, J. L. D. Comba, P.\nShirley, and C. T. Silva, Proceedings of IEEE Visualization '05, Oct.\n2005.\n\n@par Acknowledgments: This code was developed by Steven P. Callahan\nunder the supervision of Prof. Claudio T. Silva. The code also\ncontains contributions from Milan Ikits, Linh Ha, Huy T. Vo, Carlos\nE. Scheidegger, and Joao L. D. Comba.\n\n@par Acknowledgments: The work was ",
    "supported by grants, contracts,\nand gifts from the National Science Foundation, the Department of\nEnergy, the Army Research Office, and IBM.\n\n@par Acknowledgments: The port of HAVS to VTK and ParaView has been\nprimarily supported by Sandia National Labs.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLHAVSVolumeMapper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLHAVSVolumeMapper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLHAVSVolumeMapper", o) != 0)
  {
    Py_DECREF(o);
  }

}

