// python wrapper for vtkShader2
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkShader2.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkShader2(PyObject *); }
static PyTypeObject PyvtkShader2Type_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkShader2Type", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkShader2Type_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkShader2Type_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkShader2Type_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkShader2_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkShader2_Doc();


static PyObject *
PyvtkShader2_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkShader2::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkShader2::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkShader2 *tempr = vtkShader2::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkShader2 *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkShader2::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_IsSupported(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsSupported");

  vtkRenderWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindow"))
  {
    bool tempr = vtkShader2::IsSupported(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_GetSourceCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSourceCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetSourceCode() :
      op->vtkShader2::GetSourceCode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_SetSourceCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSourceCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSourceCode(temp0);
    }
    else
    {
      op->vtkShader2::SetSourceCode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_GetType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetType() :
      op->vtkShader2::GetType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_SetType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetType(temp0);
    }
    else
    {
      op->vtkShader2::SetType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_GetTypeAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTypeAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetTypeAsString() :
      op->vtkShader2::GetTypeAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_Compile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Compile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Compile();
    }
    else
    {
      op->vtkShader2::Compile();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_GetLastCompileStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastCompileStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetLastCompileStatus() :
      op->vtkShader2::GetLastCompileStatus());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_GetLastCompileLog(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastCompileLog");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetLastCompileLog() :
      op->vtkShader2::GetLastCompileLog());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_SetContext(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetContext");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  vtkRenderWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindow"))
  {
    if (ap.IsBound())
    {
      op->SetContext(temp0);
    }
    else
    {
      op->vtkShader2::SetContext(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_GetContext(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetContext");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderWindow *tempr = (ap.IsBound() ?
      op->GetContext() :
      op->vtkShader2::GetContext());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources();
    }
    else
    {
      op->vtkShader2::ReleaseGraphicsResources();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_GetId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetId() :
      op->vtkShader2::GetId());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_GetUniformVariables(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUniformVariables");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkUniformVariables *tempr = (ap.IsBound() ?
      op->GetUniformVariables() :
      op->vtkShader2::GetUniformVariables());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2_SetUniformVariables(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformVariables");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2 *op = static_cast<vtkShader2 *>(vp);

  vtkUniformVariables *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkUniformVariables"))
  {
    if (ap.IsBound())
    {
      op->SetUniformVariables(temp0);
    }
    else
    {
      op->vtkShader2::SetUniformVariables(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkShader2_Methods[] = {
  {"IsTypeOf", PyvtkShader2_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkShader2_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkShader2_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkShader2\nC++: static vtkShader2 *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkShader2_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkShader2\nC++: vtkShader2 *NewInstance()\n\n"},
  {"IsSupported", PyvtkShader2_IsSupported, METH_VARARGS,
   "V.IsSupported(vtkRenderWindow) -> bool\nC++: static bool IsSupported(vtkRenderWindow *context)\n\nReturns if the context supports the required extensions.\nExtensions are load when the context is set.\n"},
  {"GetSourceCode", PyvtkShader2_GetSourceCode, METH_VARARGS,
   "V.GetSourceCode() -> string\nC++: virtual char *GetSourceCode()\n\nString containing the shader source code. Reminder SetString\nmakes a copy of its argument.\n"},
  {"SetSourceCode", PyvtkShader2_SetSourceCode, METH_VARARGS,
   "V.SetSourceCode(string)\nC++: virtual void SetSourceCode(const char *_arg)\n\nString containing the shader source code. Reminder SetString\nmakes a copy of its argument.\n"},
  {"GetType", PyvtkShader2_GetType, METH_VARARGS,
   "V.GetType() -> int\nC++: virtual int GetType()\n\nReturn the shader type, .\n\\post valid_result: result==VTK_SHADER_TYPE_VERTEX ||\nresult==VTK_SHADER_TYPE_TESSELLATION_CONTROL ||\nresult==VTK_SHADER_TYPE_TESSELLATION_EVALUATION ||\nresult==VTK_SHADER_TYPE_GEOMETRY ||\nresult==VTK_SHADER_TYPE_FRAGMENT.\n"},
  {"SetType", PyvtkShader2_SetType, METH_VARARGS,
   "V.SetType(int)\nC++: virtual void SetType(int _arg)\n\nSet the shader type, .\n\\pre valid_type: type==VTK_SHADER_TYPE_VERTEX ||\ntype==VTK_SHADER_TYPE_TESSELLATION_CONTROL ||\ntype==VTK_SHADER_TYPE_TESSELLATION_EVALUATION ||\ntype==VTK_SHADER_TYPE_GEOMETRY || type==VTK_SHADER_TYPE_FRAGMENT.\n\\post is_set: GetType()==type.\n"},
  {"GetTypeAsString", PyvtkShader2_GetTypeAsString, METH_VARARGS,
   "V.GetTypeAsString() -> string\nC++: const char *GetTypeAsString()\n\nReturn the shader type as a string.\n"},
  {"Compile", PyvtkShader2_Compile, METH_VARARGS,
   "V.Compile()\nC++: void Compile()\n\nCompile the shader code. The result of compilation can be query\nwith GetLastCompileStatus() The log of compilation can be query\nwith GetLastCompileLog()\n\\pre SourceCode_exists: this->GetSourceCode()!=0\n"},
  {"GetLastCompileStatus", PyvtkShader2_GetLastCompileStatus, METH_VARARGS,
   "V.GetLastCompileStatus() -> bool\nC++: bool GetLastCompileStatus()\n\nTells if the last call to compile succeeded (true) or not\n(false). Initial value is false.\n"},
  {"GetLastCompileLog", PyvtkShader2_GetLastCompileLog, METH_VARARGS,
   "V.GetLastCompileLog() -> string\nC++: const char *GetLastCompileLog()\n\nReturn the log of the last call to compile as a string. Initial\nvalue is the empty string \"\"='\\0'.\n\\post result_exists: result!=0\n"},
  {"SetContext", PyvtkShader2_SetContext, METH_VARARGS,
   "V.SetContext(vtkRenderWindow)\nC++: void SetContext(vtkRenderWindow *context)\n\nGet/Set the context. This does not increase the reference count\nof the context to avoid reference loops. SetContext() may raise\nan error is the OpenGL context does not support the required\nOpenGL extensions.\n"},
  {"GetContext", PyvtkShader2_GetContext, METH_VARARGS,
   "V.GetContext() -> vtkRenderWindow\nC++: vtkRenderWindow *GetContext()\n\nGet/Set the context. This does not increase the reference count\nof the context to avoid reference loops. SetContext() may raise\nan error is the OpenGL context does not support the required\nOpenGL extensions.\n"},
  {"ReleaseGraphicsResources", PyvtkShader2_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources()\nC++: virtual void ReleaseGraphicsResources()\n\nRelease OpenGL resource (shader id).\n"},
  {"GetId", PyvtkShader2_GetId, METH_VARARGS,
   "V.GetId() -> int\nC++: virtual unsigned int GetId()\n\nReturn the OpenGL shader object id.\n"},
  {"GetUniformVariables", PyvtkShader2_GetUniformVariables, METH_VARARGS,
   "V.GetUniformVariables() -> vtkUniformVariables\nC++: virtual vtkUniformVariables *GetUniformVariables()\n\nGet/Set the list of uniform variables values. Initial value is an\nempty list (not null pointer).\n"},
  {"SetUniformVariables", PyvtkShader2_SetUniformVariables, METH_VARARGS,
   "V.SetUniformVariables(vtkUniformVariables)\nC++: virtual void SetUniformVariables(\n    vtkUniformVariables *variables)\n\nGet/Set the list of uniform variables values. Initial value is an\nempty list (not null pointer).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkShader2_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkShader2", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkShader2_StaticNew()
{
  return vtkShader2::New();
}

PyObject *PyvtkShader2_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkShader2_Type, PyvtkShader2_Methods,
    "vtkShader2",
    PyvtkShader2_Doc(), &PyvtkShader2_StaticNew);

  PyTypeObject *pytype = &PyvtkShader2_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkShader2_Doc()
{
  static const char *docstring[] = {
    "vtkShader2 - GLSL Shader\n\n",
    "Superclass: vtkObject\n\n",
    "A vtkShader2 object is made of a source code encoded into a string\nand a type, identifying the hardware programmable stage it is\nattached to. Hardware programmable stages are (or will be)\n1. vertex shader\n2. tessellation control shader\n3. tessellation evaluation shader\n4. geometry shader\n5. fragment shader\n\nNote: tessellation control shader is called hull shader in DirectX11\nNote: tessellation eva",
    "luation shader is called domain shader in\nDirectX11 Ref: OpenGL spec 4.0\nhttp://www.opengl.org/registry/doc/glspec40.core.20100311.withchanges.\npdf Ref: \"Introducing DirectX 11\"\nhttp://www.gamasutra.com/view/feature/3759/sponsored_feature_introduci\nng_.php\n\n@sa\nvtkShaderProgram2\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkShader2(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkShader2_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkShader2", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkShader2Type_Type);
  PyvtkShader2Type_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkShader2Type_Type);

  o = (PyObject *)&PyvtkShader2Type_Type;
  if (PyDict_SetItemString(dict, "vtkShader2Type", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 5; c++)
  {
    static const struct { const char *name; vtkShader2Type value; }
      constants[5] = {
        { "VTK_SHADER_TYPE_VERTEX", VTK_SHADER_TYPE_VERTEX },
        { "VTK_SHADER_TYPE_TESSELLATION_CONTROL", VTK_SHADER_TYPE_TESSELLATION_CONTROL },
        { "VTK_SHADER_TYPE_TESSELLATION_EVALUATION", VTK_SHADER_TYPE_TESSELLATION_EVALUATION },
        { "VTK_SHADER_TYPE_GEOMETRY", VTK_SHADER_TYPE_GEOMETRY },
        { "VTK_SHADER_TYPE_FRAGMENT", VTK_SHADER_TYPE_FRAGMENT },
      };

    o = PyvtkShader2Type_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(dict, constants[c].name, o);
      Py_DECREF(o);
    }
  }

}

