// python wrapper for vtkScatterPlotMapper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkScatterPlotMapper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkScatterPlotMapper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkScatterPlotMapper_ClassNew(); }

#ifndef DECLARED_PyvtkCompositePolyDataMapper2_ClassNew
extern "C" { PyObject *PyvtkCompositePolyDataMapper2_ClassNew(); }
#define DECLARED_PyvtkCompositePolyDataMapper2_ClassNew
#endif

static const char **PyvtkScatterPlotMapper_Doc();

static PyTypeObject PyvtkScatterPlotMapper_ArrayIndex_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkScatterPlotMapper.ArrayIndex", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkScatterPlotMapper_ArrayIndex_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkScatterPlotMapper_ArrayIndex_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkScatterPlotMapper_ArrayIndex_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}

static PyTypeObject PyvtkScatterPlotMapper_GlyphDrawingMode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkScatterPlotMapper.GlyphDrawingMode", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkScatterPlotMapper_GlyphDrawingMode_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkScatterPlotMapper_GlyphDrawingMode_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkScatterPlotMapper_GlyphDrawingMode_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}

static PyTypeObject PyvtkScatterPlotMapper_ScalingArrayModes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkScatterPlotMapper.ScalingArrayModes", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkScatterPlotMapper_ScalingArrayModes_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkScatterPlotMapper_ScalingArrayModes_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkScatterPlotMapper_ScalingArrayModes_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}

static PyTypeObject PyvtkScatterPlotMapper_ScaleModes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkScatterPlotMapper.ScaleModes", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkScatterPlotMapper_ScaleModes_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkScatterPlotMapper_ScaleModes_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkScatterPlotMapper_ScaleModes_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}

static PyTypeObject PyvtkScatterPlotMapper_OrientationModes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkScatterPlotMapper.OrientationModes", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkScatterPlotMapper_OrientationModes_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkScatterPlotMapper_OrientationModes_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkScatterPlotMapper_OrientationModes_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkScatterPlotMapper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkScatterPlotMapper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkScatterPlotMapper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkScatterPlotMapper *tempr = vtkScatterPlotMapper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkScatterPlotMapper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkScatterPlotMapper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_FIELD_ACTIVE_COMPONENT(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "FIELD_ACTIVE_COMPONENT");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotMapper::FIELD_ACTIVE_COMPONENT();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetArrayByFieldName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetArrayByFieldName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  typedef vtkScatterPlotMapper::ArrayIndex temp0_type;
  temp0_type temp0;
  char *temp1 = NULL;
  int temp2;
  int temp3 = 0;
  int temp4 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3, 5) &&
      ap.GetEnumValue(temp0, "vtkScatterPlotMapper.ArrayIndex") &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->SetArrayByFieldName(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkScatterPlotMapper::SetArrayByFieldName(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetArrayByFieldIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetArrayByFieldIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  typedef vtkScatterPlotMapper::ArrayIndex temp0_type;
  temp0_type temp0;
  int temp1;
  int temp2;
  int temp3 = 0;
  int temp4 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3, 5) &&
      ap.GetEnumValue(temp0, "vtkScatterPlotMapper.ArrayIndex") &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->SetArrayByFieldIndex(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkScatterPlotMapper::SetArrayByFieldIndex(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetArrayByFieldType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetArrayByFieldType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  typedef vtkScatterPlotMapper::ArrayIndex temp0_type;
  temp0_type temp0;
  int temp1;
  int temp2;
  int temp3 = 0;
  int temp4 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3, 5) &&
      ap.GetEnumValue(temp0, "vtkScatterPlotMapper.ArrayIndex") &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->SetArrayByFieldType(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkScatterPlotMapper::SetArrayByFieldType(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetArrayByPointCoord(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetArrayByPointCoord");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  typedef vtkScatterPlotMapper::ArrayIndex temp0_type;
  temp0_type temp0;
  int temp1 = 0;
  int temp2 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1, 3) &&
      ap.GetEnumValue(temp0, "vtkScatterPlotMapper.ArrayIndex") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    if (ap.IsBound())
    {
      op->SetArrayByPointCoord(temp0, temp1, temp2);
    }
    else
    {
      op->vtkScatterPlotMapper::SetArrayByPointCoord(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetArrayByName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetArrayByName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  typedef vtkScatterPlotMapper::ArrayIndex temp0_type;
  temp0_type temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetEnumValue(temp0, "vtkScatterPlotMapper.ArrayIndex") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetArrayByName(temp0, temp1);
    }
    else
    {
      op->vtkScatterPlotMapper::SetArrayByName(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetXCoordsArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetXCoordsArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetXCoordsArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetXCoordsArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetYCoordsArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetYCoordsArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetYCoordsArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetYCoordsArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetZCoordsArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetZCoordsArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetZCoordsArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetZCoordsArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetColorArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetColorArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetColorArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetColorArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphXScalingArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphXScalingArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphXScalingArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphXScalingArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphYScalingArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphYScalingArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphYScalingArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphYScalingArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphZScalingArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphZScalingArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphZScalingArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphZScalingArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphSourceArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphSourceArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphSourceArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphSourceArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphXOrientationArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphXOrientationArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphXOrientationArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphXOrientationArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphYOrientationArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphYOrientationArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphYOrientationArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphYOrientationArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphZOrientationArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphZOrientationArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphZOrientationArray(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphZOrientationArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetArray_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  typedef vtkScatterPlotMapper::ArrayIndex temp0_type;
  temp0_type temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetEnumValue(temp0, "vtkScatterPlotMapper.ArrayIndex"))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->GetArray(temp0) :
      op->vtkScatterPlotMapper::GetArray(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkScatterPlotMapper_GetArray_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  typedef vtkScatterPlotMapper::ArrayIndex temp0_type;
  temp0_type temp0;
  vtkDataSet *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetEnumValue(temp0, "vtkScatterPlotMapper.ArrayIndex") &&
      ap.GetVTKObject(temp1, "vtkDataSet"))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->GetArray(temp0, temp1) :
      op->vtkScatterPlotMapper::GetArray(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkScatterPlotMapper_GetArray(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkScatterPlotMapper_GetArray_s1(self, args);
    case 2:
      return PyvtkScatterPlotMapper_GetArray_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetArray");
  return NULL;
}



static PyObject *
PyvtkScatterPlotMapper_SetThreeDMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetThreeDMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetThreeDMode(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetThreeDMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetThreeDMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetThreeDMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetThreeDMode() :
      op->vtkScatterPlotMapper::GetThreeDMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_ThreeDModeOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ThreeDModeOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ThreeDModeOn();
    }
    else
    {
      op->vtkScatterPlotMapper::ThreeDModeOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_ThreeDModeOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ThreeDModeOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ThreeDModeOff();
    }
    else
    {
      op->vtkScatterPlotMapper::ThreeDModeOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetColorize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetColorize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetColorize(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetColorize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetColorize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColorize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetColorize() :
      op->vtkScatterPlotMapper::GetColorize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_ColorizeOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ColorizeOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ColorizeOn();
    }
    else
    {
      op->vtkScatterPlotMapper::ColorizeOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_ColorizeOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ColorizeOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ColorizeOff();
    }
    else
    {
      op->vtkScatterPlotMapper::ColorizeOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphMode(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetGlyphMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlyphMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetGlyphMode() :
      op->vtkScatterPlotMapper::GetGlyphMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetScalingArrayMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalingArrayMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScalingArrayMode(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetScalingArrayMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetScalingArrayMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalingArrayMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetScalingArrayMode() :
      op->vtkScatterPlotMapper::GetScalingArrayMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetScaleMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScaleMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScaleMode(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetScaleMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetScaleMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScaleMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetScaleMode() :
      op->vtkScatterPlotMapper::GetScaleMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetScaleFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScaleFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScaleFactor(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetScaleFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetScaleFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScaleFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetScaleFactor() :
      op->vtkScatterPlotMapper::GetScaleFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetOrientationMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOrientationMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOrientationMode(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetOrientationMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetOrientationMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOrientationMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOrientationMode() :
      op->vtkScatterPlotMapper::GetOrientationMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetNestedDisplayLists(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNestedDisplayLists");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNestedDisplayLists(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetNestedDisplayLists(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetNestedDisplayLists(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNestedDisplayLists");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNestedDisplayLists() :
      op->vtkScatterPlotMapper::GetNestedDisplayLists());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_NestedDisplayListsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NestedDisplayListsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->NestedDisplayListsOn();
    }
    else
    {
      op->vtkScatterPlotMapper::NestedDisplayListsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_NestedDisplayListsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NestedDisplayListsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->NestedDisplayListsOff();
    }
    else
    {
      op->vtkScatterPlotMapper::NestedDisplayListsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetParallelToCamera(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParallelToCamera");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetParallelToCamera(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetParallelToCamera(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetParallelToCamera(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParallelToCamera");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetParallelToCamera() :
      op->vtkScatterPlotMapper::GetParallelToCamera());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_ParallelToCameraOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ParallelToCameraOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ParallelToCameraOn();
    }
    else
    {
      op->vtkScatterPlotMapper::ParallelToCameraOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_ParallelToCameraOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ParallelToCameraOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ParallelToCameraOff();
    }
    else
    {
      op->vtkScatterPlotMapper::ParallelToCameraOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_SetGlyphSourceConnection_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphSourceConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  int temp0;
  vtkAlgorithmOutput *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetGlyphSourceConnection(temp0, temp1);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphSourceConnection(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkScatterPlotMapper_SetGlyphSourceConnection_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphSourceConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  vtkAlgorithmOutput *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetGlyphSourceConnection(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::SetGlyphSourceConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkScatterPlotMapper_SetGlyphSourceConnection(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkScatterPlotMapper_SetGlyphSourceConnection_s1(self, args);
    case 1:
      return PyvtkScatterPlotMapper_SetGlyphSourceConnection_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetGlyphSourceConnection");
  return NULL;
}



static PyObject *
PyvtkScatterPlotMapper_AddGlyphSourceConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddGlyphSourceConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  vtkAlgorithmOutput *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->AddGlyphSourceConnection(temp0);
    }
    else
    {
      op->vtkScatterPlotMapper::AddGlyphSourceConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_GetGlyphSource(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlyphSource");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  int temp0 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    vtkPolyData *tempr = (ap.IsBound() ?
      op->GetGlyphSource(temp0) :
      op->vtkScatterPlotMapper::GetGlyphSource(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotMapper_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotMapper *op = static_cast<vtkScatterPlotMapper *>(vp);

  vtkRenderer *temp0 = NULL;
  vtkActor *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkRenderer") &&
      ap.GetVTKObject(temp1, "vtkActor"))
  {
    if (ap.IsBound())
    {
      op->Render(temp0, temp1);
    }
    else
    {
      op->vtkScatterPlotMapper::Render(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkScatterPlotMapper_Methods[] = {
  {"IsTypeOf", PyvtkScatterPlotMapper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkScatterPlotMapper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkScatterPlotMapper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkScatterPlotMapper\nC++: static vtkScatterPlotMapper *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkScatterPlotMapper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkScatterPlotMapper\nC++: vtkScatterPlotMapper *NewInstance()\n\n"},
  {"FIELD_ACTIVE_COMPONENT", PyvtkScatterPlotMapper_FIELD_ACTIVE_COMPONENT, METH_VARARGS,
   "V.FIELD_ACTIVE_COMPONENT() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *FIELD_ACTIVE_COMPONENT()\n\n"},
  {"SetArrayByFieldName", PyvtkScatterPlotMapper_SetArrayByFieldName, METH_VARARGS,
   "V.SetArrayByFieldName(ArrayIndex, string, int, int, int)\nC++: void SetArrayByFieldName(ArrayIndex idx,\n    const char *arrayName, int fieldAssociation, int component=0,\n    int connection=0)\n\nSet the name of the point array to use as a mask for generating\nthe glyphs. This is a convenience method. The same effect can be\nachieved by using SetInputArrayToProcess(idx, 0, connection,\nvtkDataObject::FIELD_ASSOCIATION_POINTS, arrayName) void\nSetMaskArray();\n"},
  {"SetArrayByFieldIndex", PyvtkScatterPlotMapper_SetArrayByFieldIndex, METH_VARARGS,
   "V.SetArrayByFieldIndex(ArrayIndex, int, int, int, int)\nC++: void SetArrayByFieldIndex(ArrayIndex idx, int fiedIndex,\n    int fieldAssociation, int component=0, int connection=0)\n\nSet the name of the point array to use as a mask for generating\nthe glyphs. This is a convenience method. The same effect can be\nachieved by using SetInputArrayToProcess(idx, 0, connection,\nvtkDataObject::FIELD_ASSOCIATION_POINTS, arrayName) void\nSetMaskArray();\n"},
  {"SetArrayByFieldType", PyvtkScatterPlotMapper_SetArrayByFieldType, METH_VARARGS,
   "V.SetArrayByFieldType(ArrayIndex, int, int, int, int)\nC++: void SetArrayByFieldType(ArrayIndex idx,\n    int fieldAttributeType, int fieldAssociation, int component=0,\n     int connection=0)\n\nSet the point attribute to use for generating the glyphs.idx is\none of the following:\n\\li vtkScatterPlotMapper::X_COORDS\n\\li vtkScatterPlotMapper::Y_COORDS\n\\li vtkScatterPlotMapper::Z_COORDS\n\\li vtkScatterPlotMapper::COLOR\n\\li vtkScatterPlotMapper::GLYPH_SCALING\n\\li vtkScatterPlotMapper::GLYPH_ORIENTATION\n\\li vtkScatterPlotMapper::GLYPH_SHAPEfieldAttributeType is one of\nthe following:\n\\li vtkDataSetAttributes::SCALARS\n\\li vtkDataSetAttributes::VECTORS\n\\li vtkDataSetAttributes::NORMALS\n\\li vtkDataSetAttributes::TCOORDS\n\\li vtkDataSetAttributes::TENSORS\n\n* This is a convenience method. This internally  same effect can\n  be achieved by using\n* SetInputArrayToProcess(idx, 0, connection,\n* vtkDataObject::FIELD_ASSOCIATION_POINTS, fieldAttributeType)\n"},
  {"SetArrayByPointCoord", PyvtkScatterPlotMapper_SetArrayByPointCoord, METH_VARARGS,
   "V.SetArrayByPointCoord(ArrayIndex, int, int)\nC++: void SetArrayByPointCoord(ArrayIndex idx, int component=0,\n    int connection=0)\n\n"},
  {"SetArrayByName", PyvtkScatterPlotMapper_SetArrayByName, METH_VARARGS,
   "V.SetArrayByName(ArrayIndex, string)\nC++: void SetArrayByName(ArrayIndex idx, const char *arrayName)\n\n"},
  {"SetXCoordsArray", PyvtkScatterPlotMapper_SetXCoordsArray, METH_VARARGS,
   "V.SetXCoordsArray(string)\nC++: void SetXCoordsArray(const char *arrayName)\n\n"},
  {"SetYCoordsArray", PyvtkScatterPlotMapper_SetYCoordsArray, METH_VARARGS,
   "V.SetYCoordsArray(string)\nC++: void SetYCoordsArray(const char *arrayName)\n\n"},
  {"SetZCoordsArray", PyvtkScatterPlotMapper_SetZCoordsArray, METH_VARARGS,
   "V.SetZCoordsArray(string)\nC++: void SetZCoordsArray(const char *arrayName)\n\n"},
  {"SetColorArray", PyvtkScatterPlotMapper_SetColorArray, METH_VARARGS,
   "V.SetColorArray(string)\nC++: void SetColorArray(const char *arrayName)\n\n"},
  {"SetGlyphXScalingArray", PyvtkScatterPlotMapper_SetGlyphXScalingArray, METH_VARARGS,
   "V.SetGlyphXScalingArray(string)\nC++: void SetGlyphXScalingArray(const char *arrayName)\n\n"},
  {"SetGlyphYScalingArray", PyvtkScatterPlotMapper_SetGlyphYScalingArray, METH_VARARGS,
   "V.SetGlyphYScalingArray(string)\nC++: void SetGlyphYScalingArray(const char *arrayName)\n\n"},
  {"SetGlyphZScalingArray", PyvtkScatterPlotMapper_SetGlyphZScalingArray, METH_VARARGS,
   "V.SetGlyphZScalingArray(string)\nC++: void SetGlyphZScalingArray(const char *arrayName)\n\n"},
  {"SetGlyphSourceArray", PyvtkScatterPlotMapper_SetGlyphSourceArray, METH_VARARGS,
   "V.SetGlyphSourceArray(string)\nC++: void SetGlyphSourceArray(const char *arrayName)\n\n"},
  {"SetGlyphXOrientationArray", PyvtkScatterPlotMapper_SetGlyphXOrientationArray, METH_VARARGS,
   "V.SetGlyphXOrientationArray(string)\nC++: void SetGlyphXOrientationArray(const char *arrayName)\n\n"},
  {"SetGlyphYOrientationArray", PyvtkScatterPlotMapper_SetGlyphYOrientationArray, METH_VARARGS,
   "V.SetGlyphYOrientationArray(string)\nC++: void SetGlyphYOrientationArray(const char *arrayName)\n\n"},
  {"SetGlyphZOrientationArray", PyvtkScatterPlotMapper_SetGlyphZOrientationArray, METH_VARARGS,
   "V.SetGlyphZOrientationArray(string)\nC++: void SetGlyphZOrientationArray(const char *arrayName)\n\n"},
  {"GetArray", PyvtkScatterPlotMapper_GetArray, METH_VARARGS,
   "V.GetArray(ArrayIndex) -> vtkDataArray\nC++: vtkDataArray *GetArray(ArrayIndex idx)\nV.GetArray(ArrayIndex, vtkDataSet) -> vtkDataArray\nC++: vtkDataArray *GetArray(ArrayIndex idx, vtkDataSet *input)\n\n"},
  {"SetThreeDMode", PyvtkScatterPlotMapper_SetThreeDMode, METH_VARARGS,
   "V.SetThreeDMode(bool)\nC++: virtual void SetThreeDMode(bool _arg)\n\nEnable or not the third (z) coordinate for 3D rendering (instead\nof 2D). Note: To work, the Z_Coords index array must be given.\n"},
  {"GetThreeDMode", PyvtkScatterPlotMapper_GetThreeDMode, METH_VARARGS,
   "V.GetThreeDMode() -> bool\nC++: virtual bool GetThreeDMode()\n\nEnable or not the third (z) coordinate for 3D rendering (instead\nof 2D). Note: To work, the Z_Coords index array must be given.\n"},
  {"ThreeDModeOn", PyvtkScatterPlotMapper_ThreeDModeOn, METH_VARARGS,
   "V.ThreeDModeOn()\nC++: virtual void ThreeDModeOn()\n\nEnable or not the third (z) coordinate for 3D rendering (instead\nof 2D). Note: To work, the Z_Coords index array must be given.\n"},
  {"ThreeDModeOff", PyvtkScatterPlotMapper_ThreeDModeOff, METH_VARARGS,
   "V.ThreeDModeOff()\nC++: virtual void ThreeDModeOff()\n\nEnable or not the third (z) coordinate for 3D rendering (instead\nof 2D). Note: To work, the Z_Coords index array must be given.\n"},
  {"SetColorize", PyvtkScatterPlotMapper_SetColorize, METH_VARARGS,
   "V.SetColorize(bool)\nC++: virtual void SetColorize(bool _arg)\n\nEnable or not the color painting at each point. Note: To work,\nthe Color index array must be given.\n"},
  {"GetColorize", PyvtkScatterPlotMapper_GetColorize, METH_VARARGS,
   "V.GetColorize() -> bool\nC++: virtual bool GetColorize()\n\nEnable or not the color painting at each point. Note: To work,\nthe Color index array must be given.\n"},
  {"ColorizeOn", PyvtkScatterPlotMapper_ColorizeOn, METH_VARARGS,
   "V.ColorizeOn()\nC++: virtual void ColorizeOn()\n\nEnable or not the color painting at each point. Note: To work,\nthe Color index array must be given.\n"},
  {"ColorizeOff", PyvtkScatterPlotMapper_ColorizeOff, METH_VARARGS,
   "V.ColorizeOff()\nC++: virtual void ColorizeOff()\n\nEnable or not the color painting at each point. Note: To work,\nthe Color index array must be given.\n"},
  {"SetGlyphMode", PyvtkScatterPlotMapper_SetGlyphMode, METH_VARARGS,
   "V.SetGlyphMode(int)\nC++: virtual void SetGlyphMode(int _arg)\n\nEnable or not the Glyph representation at each point. Note: To\nwork, at least 1 Glyph polydata input must be set and the Glyph\nindex array must be given.\n"},
  {"GetGlyphMode", PyvtkScatterPlotMapper_GetGlyphMode, METH_VARARGS,
   "V.GetGlyphMode() -> int\nC++: virtual int GetGlyphMode()\n\nEnable or not the Glyph representation at each point. Note: To\nwork, at least 1 Glyph polydata input must be set and the Glyph\nindex array must be given.\n"},
  {"SetScalingArrayMode", PyvtkScatterPlotMapper_SetScalingArrayMode, METH_VARARGS,
   "V.SetScalingArrayMode(int)\nC++: virtual void SetScalingArrayMode(int _arg)\n\nIf the GlyphMode has ScaledGlyph turned on, ScalingArrayMode\ndescribes how to data in the different GLYPH_[X,Y,Z]_SCALE arrays\n"},
  {"GetScalingArrayMode", PyvtkScatterPlotMapper_GetScalingArrayMode, METH_VARARGS,
   "V.GetScalingArrayMode() -> int\nC++: virtual int GetScalingArrayMode()\n\nIf the GlyphMode has ScaledGlyph turned on, ScalingArrayMode\ndescribes how to data in the different GLYPH_[X,Y,Z]_SCALE arrays\n"},
  {"SetScaleMode", PyvtkScatterPlotMapper_SetScaleMode, METH_VARARGS,
   "V.SetScaleMode(int)\nC++: virtual void SetScaleMode(int _arg)\n\nIf the GlyphMode has ScaledGlyph turned on, decide how to scale\nthe glyph. By Magnitude or components.\n"},
  {"GetScaleMode", PyvtkScatterPlotMapper_GetScaleMode, METH_VARARGS,
   "V.GetScaleMode() -> int\nC++: virtual int GetScaleMode()\n\nIf the GlyphMode has ScaledGlyph turned on, decide how to scale\nthe glyph. By Magnitude or components.\n"},
  {"SetScaleFactor", PyvtkScatterPlotMapper_SetScaleFactor, METH_VARARGS,
   "V.SetScaleFactor(float)\nC++: virtual void SetScaleFactor(double _arg)\n\nSpecify scale factor to scale object by. This is used only when\nScaling is On.\n"},
  {"GetScaleFactor", PyvtkScatterPlotMapper_GetScaleFactor, METH_VARARGS,
   "V.GetScaleFactor() -> float\nC++: virtual double GetScaleFactor()\n\nSpecify scale factor to scale object by. This is used only when\nScaling is On.\n"},
  {"SetOrientationMode", PyvtkScatterPlotMapper_SetOrientationMode, METH_VARARGS,
   "V.SetOrientationMode(int)\nC++: virtual void SetOrientationMode(int _arg)\n\n"},
  {"GetOrientationMode", PyvtkScatterPlotMapper_GetOrientationMode, METH_VARARGS,
   "V.GetOrientationMode() -> int\nC++: virtual int GetOrientationMode()\n\n"},
  {"SetNestedDisplayLists", PyvtkScatterPlotMapper_SetNestedDisplayLists, METH_VARARGS,
   "V.SetNestedDisplayLists(bool)\nC++: virtual void SetNestedDisplayLists(bool _arg)\n\nIf immediate mode is off, if Glyphs are in use and if\nNestedDisplayLists is false, only the mappers of each glyph use\ndisplay lists. If true, in addition, matrices transforms and\ncolor per glyph are also in a parent display list. Not relevant\nif immediate mode is on. For debugging/profiling purpose. Initial\nvalue is true.\n"},
  {"GetNestedDisplayLists", PyvtkScatterPlotMapper_GetNestedDisplayLists, METH_VARARGS,
   "V.GetNestedDisplayLists() -> bool\nC++: virtual bool GetNestedDisplayLists()\n\nIf immediate mode is off, if Glyphs are in use and if\nNestedDisplayLists is false, only the mappers of each glyph use\ndisplay lists. If true, in addition, matrices transforms and\ncolor per glyph are also in a parent display list. Not relevant\nif immediate mode is on. For debugging/profiling purpose. Initial\nvalue is true.\n"},
  {"NestedDisplayListsOn", PyvtkScatterPlotMapper_NestedDisplayListsOn, METH_VARARGS,
   "V.NestedDisplayListsOn()\nC++: virtual void NestedDisplayListsOn()\n\nIf immediate mode is off, if Glyphs are in use and if\nNestedDisplayLists is false, only the mappers of each glyph use\ndisplay lists. If true, in addition, matrices transforms and\ncolor per glyph are also in a parent display list. Not relevant\nif immediate mode is on. For debugging/profiling purpose. Initial\nvalue is true.\n"},
  {"NestedDisplayListsOff", PyvtkScatterPlotMapper_NestedDisplayListsOff, METH_VARARGS,
   "V.NestedDisplayListsOff()\nC++: virtual void NestedDisplayListsOff()\n\nIf immediate mode is off, if Glyphs are in use and if\nNestedDisplayLists is false, only the mappers of each glyph use\ndisplay lists. If true, in addition, matrices transforms and\ncolor per glyph are also in a parent display list. Not relevant\nif immediate mode is on. For debugging/profiling purpose. Initial\nvalue is true.\n"},
  {"SetParallelToCamera", PyvtkScatterPlotMapper_SetParallelToCamera, METH_VARARGS,
   "V.SetParallelToCamera(bool)\nC++: virtual void SetParallelToCamera(bool _arg)\n\nWhen the glyphs are in 2D, it might be useful to force them to be\nshown parallel to the camera.\n"},
  {"GetParallelToCamera", PyvtkScatterPlotMapper_GetParallelToCamera, METH_VARARGS,
   "V.GetParallelToCamera() -> bool\nC++: virtual bool GetParallelToCamera()\n\nWhen the glyphs are in 2D, it might be useful to force them to be\nshown parallel to the camera.\n"},
  {"ParallelToCameraOn", PyvtkScatterPlotMapper_ParallelToCameraOn, METH_VARARGS,
   "V.ParallelToCameraOn()\nC++: virtual void ParallelToCameraOn()\n\nWhen the glyphs are in 2D, it might be useful to force them to be\nshown parallel to the camera.\n"},
  {"ParallelToCameraOff", PyvtkScatterPlotMapper_ParallelToCameraOff, METH_VARARGS,
   "V.ParallelToCameraOff()\nC++: virtual void ParallelToCameraOff()\n\nWhen the glyphs are in 2D, it might be useful to force them to be\nshown parallel to the camera.\n"},
  {"SetGlyphSourceConnection", PyvtkScatterPlotMapper_SetGlyphSourceConnection, METH_VARARGS,
   "V.SetGlyphSourceConnection(int, vtkAlgorithmOutput)\nC++: void SetGlyphSourceConnection(int id,\n    vtkAlgorithmOutput *algOutput)\nV.SetGlyphSourceConnection(vtkAlgorithmOutput)\nC++: void SetGlyphSourceConnection(vtkAlgorithmOutput *algOutput)\n\nSpecify a source object at a specified table location. New style.\nSource connection is stored in port 1. This method is equivalent\nto SetInputConnection(1, id, outputPort).\n"},
  {"AddGlyphSourceConnection", PyvtkScatterPlotMapper_AddGlyphSourceConnection, METH_VARARGS,
   "V.AddGlyphSourceConnection(vtkAlgorithmOutput)\nC++: void AddGlyphSourceConnection(vtkAlgorithmOutput *algOutput)\n\nSpecify a source object at a specified table location. New style.\nSource connection is stored in port 1. This method is equivalent\nto SetInputConnection(1, id, outputPort).\n"},
  {"GetGlyphSource", PyvtkScatterPlotMapper_GetGlyphSource, METH_VARARGS,
   "V.GetGlyphSource(int) -> vtkPolyData\nC++: vtkPolyData *GetGlyphSource(int id=0)\n\n"},
  {"Render", PyvtkScatterPlotMapper_Render, METH_VARARGS,
   "V.Render(vtkRenderer, vtkActor)\nC++: virtual void Render(vtkRenderer *renderer, vtkActor *actor)\n\nReimplemented to allow \"real\" pre rendering by\nvtkScatterPlotPainter Indeed the vtkPainter::PrepareForRendering\nis not exactly a prepare for rendering (the rendering already\nstarted).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkScatterPlotMapper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkScatterPlotMapper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkScatterPlotMapper_StaticNew()
{
  return vtkScatterPlotMapper::New();
}

PyObject *PyvtkScatterPlotMapper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkScatterPlotMapper_Type, PyvtkScatterPlotMapper_Methods,
    "vtkScatterPlotMapper",
    PyvtkScatterPlotMapper_Doc(), &PyvtkScatterPlotMapper_StaticNew);

  PyTypeObject *pytype = &PyvtkScatterPlotMapper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCompositePolyDataMapper2_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkScatterPlotMapper_ArrayIndex_Type);
  PyvtkScatterPlotMapper_ArrayIndex_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkScatterPlotMapper_ArrayIndex_Type);

  o = (PyObject *)&PyvtkScatterPlotMapper_ArrayIndex_Type;
  if (PyDict_SetItemString(d, "ArrayIndex", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkScatterPlotMapper_GlyphDrawingMode_Type);
  PyvtkScatterPlotMapper_GlyphDrawingMode_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkScatterPlotMapper_GlyphDrawingMode_Type);

  o = (PyObject *)&PyvtkScatterPlotMapper_GlyphDrawingMode_Type;
  if (PyDict_SetItemString(d, "GlyphDrawingMode", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkScatterPlotMapper_ScalingArrayModes_Type);
  PyvtkScatterPlotMapper_ScalingArrayModes_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkScatterPlotMapper_ScalingArrayModes_Type);

  o = (PyObject *)&PyvtkScatterPlotMapper_ScalingArrayModes_Type;
  if (PyDict_SetItemString(d, "ScalingArrayModes", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkScatterPlotMapper_ScaleModes_Type);
  PyvtkScatterPlotMapper_ScaleModes_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkScatterPlotMapper_ScaleModes_Type);

  o = (PyObject *)&PyvtkScatterPlotMapper_ScaleModes_Type;
  if (PyDict_SetItemString(d, "ScaleModes", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkScatterPlotMapper_OrientationModes_Type);
  PyvtkScatterPlotMapper_OrientationModes_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkScatterPlotMapper_OrientationModes_Type);

  o = (PyObject *)&PyvtkScatterPlotMapper_OrientationModes_Type;
  if (PyDict_SetItemString(d, "OrientationModes", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 12; c++)
  {
    typedef vtkScatterPlotMapper::ArrayIndex cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[12] = {
        { "X_COORDS", vtkScatterPlotMapper::X_COORDS },
        { "Y_COORDS", vtkScatterPlotMapper::Y_COORDS },
        { "Z_COORDS", vtkScatterPlotMapper::Z_COORDS },
        { "COLOR", vtkScatterPlotMapper::COLOR },
        { "GLYPH_X_SCALE", vtkScatterPlotMapper::GLYPH_X_SCALE },
        { "GLYPH_Y_SCALE", vtkScatterPlotMapper::GLYPH_Y_SCALE },
        { "GLYPH_Z_SCALE", vtkScatterPlotMapper::GLYPH_Z_SCALE },
        { "GLYPH_SOURCE", vtkScatterPlotMapper::GLYPH_SOURCE },
        { "GLYPH_X_ORIENTATION", vtkScatterPlotMapper::GLYPH_X_ORIENTATION },
        { "GLYPH_Y_ORIENTATION", vtkScatterPlotMapper::GLYPH_Y_ORIENTATION },
        { "GLYPH_Z_ORIENTATION", vtkScatterPlotMapper::GLYPH_Z_ORIENTATION },
        { "NUMBER_OF_ARRAYS", vtkScatterPlotMapper::NUMBER_OF_ARRAYS },
      };

    o = PyvtkScatterPlotMapper_ArrayIndex_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 5; c++)
  {
    typedef vtkScatterPlotMapper::GlyphDrawingMode cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[5] = {
        { "NoGlyph", vtkScatterPlotMapper::NoGlyph },
        { "UseGlyph", vtkScatterPlotMapper::UseGlyph },
        { "ScaledGlyph", vtkScatterPlotMapper::ScaledGlyph },
        { "UseMultiGlyph", vtkScatterPlotMapper::UseMultiGlyph },
        { "OrientedGlyph", vtkScatterPlotMapper::OrientedGlyph },
      };

    o = PyvtkScatterPlotMapper_GlyphDrawingMode_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 3; c++)
  {
    typedef vtkScatterPlotMapper::ScalingArrayModes cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[3] = {
        { "Xc_Yc_Zc", vtkScatterPlotMapper::Xc_Yc_Zc },
        { "Xc0_Xc1_Xc2", vtkScatterPlotMapper::Xc0_Xc1_Xc2 },
        { "Xc_Xc_Xc", vtkScatterPlotMapper::Xc_Xc_Xc },
      };

    o = PyvtkScatterPlotMapper_ScalingArrayModes_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkScatterPlotMapper::ScaleModes cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "SCALE_BY_MAGNITUDE", vtkScatterPlotMapper::SCALE_BY_MAGNITUDE },
        { "SCALE_BY_COMPONENTS", vtkScatterPlotMapper::SCALE_BY_COMPONENTS },
      };

    o = PyvtkScatterPlotMapper_ScaleModes_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkScatterPlotMapper::OrientationModes cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "DIRECTION", vtkScatterPlotMapper::DIRECTION },
        { "ROTATION", vtkScatterPlotMapper::ROTATION },
      };

    o = PyvtkScatterPlotMapper_OrientationModes_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkScatterPlotMapper_Doc()
{
  static const char *docstring[] = {
    "vtkScatterPlotMapper - Display a vtkDataSet with flexibility\n\n",
    "Superclass: vtkCompositePolyDataMapper2\n\n",
    "The mappers gives flexibility in the display of the input. By setting\nthe arrays to process, every element of the display can be\ncontrolled. i.e. the coordinates of the points can be controlled by\nany field array or the color of the points can controlled by the\nx-axes.\n\n@sa\nvtkGlyph3D, vtkCompositePolyDataMapper2\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkScatterPlotMapper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkScatterPlotMapper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkScatterPlotMapper", o) != 0)
  {
    Py_DECREF(o);
  }

}

