// python wrapper for vtkShadowMapBakerPass
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkShadowMapBakerPass.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkShadowMapBakerPass(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkShadowMapBakerPass_ClassNew(); }

#ifndef DECLARED_PyvtkRenderPass_ClassNew
extern "C" { PyObject *PyvtkRenderPass_ClassNew(); }
#define DECLARED_PyvtkRenderPass_ClassNew
#endif

static const char **PyvtkShadowMapBakerPass_Doc();


static PyObject *
PyvtkShadowMapBakerPass_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkShadowMapBakerPass::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkShadowMapBakerPass::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkShadowMapBakerPass *tempr = vtkShadowMapBakerPass::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkShadowMapBakerPass *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkShadowMapBakerPass::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_OCCLUDER(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "OCCLUDER");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkShadowMapBakerPass::OCCLUDER();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_RECEIVER(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "RECEIVER");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkShadowMapBakerPass::RECEIVER();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkShadowMapBakerPass::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetOpaquePass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOpaquePass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetOpaquePass() :
      op->vtkShadowMapBakerPass::GetOpaquePass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_SetOpaquePass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOpaquePass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetOpaquePass(temp0);
    }
    else
    {
      op->vtkShadowMapBakerPass::SetOpaquePass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetCompositeZPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompositeZPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetCompositeZPass() :
      op->vtkShadowMapBakerPass::GetCompositeZPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_SetCompositeZPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompositeZPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetCompositeZPass(temp0);
    }
    else
    {
      op->vtkShadowMapBakerPass::SetCompositeZPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_SetResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetResolution(temp0);
    }
    else
    {
      op->vtkShadowMapBakerPass::SetResolution(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetResolution() :
      op->vtkShadowMapBakerPass::GetResolution());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_SetPolygonOffsetFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPolygonOffsetFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPolygonOffsetFactor(temp0);
    }
    else
    {
      op->vtkShadowMapBakerPass::SetPolygonOffsetFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetPolygonOffsetFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPolygonOffsetFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetPolygonOffsetFactor() :
      op->vtkShadowMapBakerPass::GetPolygonOffsetFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_SetPolygonOffsetUnits(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPolygonOffsetUnits");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPolygonOffsetUnits(temp0);
    }
    else
    {
      op->vtkShadowMapBakerPass::SetPolygonOffsetUnits(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetPolygonOffsetUnits(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPolygonOffsetUnits");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetPolygonOffsetUnits() :
      op->vtkShadowMapBakerPass::GetPolygonOffsetUnits());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetHasShadows(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHasShadows");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetHasShadows() :
      op->vtkShadowMapBakerPass::GetHasShadows());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_LightCreatesShadow(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LightCreatesShadow");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  vtkLight *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkLight"))
  {
    bool tempr = (ap.IsBound() ?
      op->LightCreatesShadow(temp0) :
      op->vtkShadowMapBakerPass::LightCreatesShadow(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetShadowMaps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShadowMaps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkShadowMapBakerPassTextures *tempr = (ap.IsBound() ?
      op->GetShadowMaps() :
      op->vtkShadowMapBakerPass::GetShadowMaps());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetLightCameras(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLightCameras");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkShadowMapBakerPassLightCameras *tempr = (ap.IsBound() ?
      op->GetLightCameras() :
      op->vtkShadowMapBakerPass::GetLightCameras());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_GetNeedUpdate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNeedUpdate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetNeedUpdate() :
      op->vtkShadowMapBakerPass::GetNeedUpdate());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShadowMapBakerPass_SetUpToDate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUpToDate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShadowMapBakerPass *op = static_cast<vtkShadowMapBakerPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetUpToDate();
    }
    else
    {
      op->vtkShadowMapBakerPass::SetUpToDate();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkShadowMapBakerPass_Methods[] = {
  {"IsTypeOf", PyvtkShadowMapBakerPass_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkShadowMapBakerPass_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkShadowMapBakerPass_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkShadowMapBakerPass\nC++: static vtkShadowMapBakerPass *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkShadowMapBakerPass_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkShadowMapBakerPass\nC++: vtkShadowMapBakerPass *NewInstance()\n\n"},
  {"OCCLUDER", PyvtkShadowMapBakerPass_OCCLUDER, METH_VARARGS,
   "V.OCCLUDER() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *OCCLUDER()\n\nIf this key exists on the PropertyKeys of a prop, the prop is\nviewed as a light occluder (ie it casts shadows). This key is not\nmutually exclusive with the RECEIVER() key.\n"},
  {"RECEIVER", PyvtkShadowMapBakerPass_RECEIVER, METH_VARARGS,
   "V.RECEIVER() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *RECEIVER()\n\n"},
  {"ReleaseGraphicsResources", PyvtkShadowMapBakerPass_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *w)\n\nRelease graphics resources and ask components to release their\nown resources.\n\\pre w_exists: w!=0\n"},
  {"GetOpaquePass", PyvtkShadowMapBakerPass_GetOpaquePass, METH_VARARGS,
   "V.GetOpaquePass() -> vtkRenderPass\nC++: virtual vtkRenderPass *GetOpaquePass()\n\nDelegate for rendering the opaque polygonal geometry. If it is\nNULL, nothing will be rendered and a warning will be emitted. It\nis usually set to a vtkCameraPass with a sequence of\nvtkLightPass/vtkOpaquePass. Initial value is a NULL pointer.\n"},
  {"SetOpaquePass", PyvtkShadowMapBakerPass_SetOpaquePass, METH_VARARGS,
   "V.SetOpaquePass(vtkRenderPass)\nC++: virtual void SetOpaquePass(vtkRenderPass *opaquePass)\n\nDelegate for rendering the opaque polygonal geometry. If it is\nNULL, nothing will be rendered and a warning will be emitted. It\nis usually set to a vtkCameraPass with a sequence of\nvtkLightPass/vtkOpaquePass. Initial value is a NULL pointer.\n"},
  {"GetCompositeZPass", PyvtkShadowMapBakerPass_GetCompositeZPass, METH_VARARGS,
   "V.GetCompositeZPass() -> vtkRenderPass\nC++: virtual vtkRenderPass *GetCompositeZPass()\n\nDelegate for compositing of the shadow maps across processors. If\nit is NULL, there is no z compositing. It is usually set to a\nvtkCompositeZPass (Parallel package). Initial value is a NULL\npointer.\n"},
  {"SetCompositeZPass", PyvtkShadowMapBakerPass_SetCompositeZPass, METH_VARARGS,
   "V.SetCompositeZPass(vtkRenderPass)\nC++: virtual void SetCompositeZPass(vtkRenderPass *compositeZPass)\n\nDelegate for compositing of the shadow maps across processors. If\nit is NULL, there is no z compositing. It is usually set to a\nvtkCompositeZPass (Parallel package). Initial value is a NULL\npointer.\n"},
  {"SetResolution", PyvtkShadowMapBakerPass_SetResolution, METH_VARARGS,
   "V.SetResolution(int)\nC++: virtual void SetResolution(unsigned int _arg)\n\nSet/Get the number of pixels in each dimension of the shadow maps\n(shadow maps are square). Initial value is 256. The greater the\nbetter. Resolution does not have to be a power-of-two value.\n"},
  {"GetResolution", PyvtkShadowMapBakerPass_GetResolution, METH_VARARGS,
   "V.GetResolution() -> int\nC++: virtual unsigned int GetResolution()\n\nSet/Get the number of pixels in each dimension of the shadow maps\n(shadow maps are square). Initial value is 256. The greater the\nbetter. Resolution does not have to be a power-of-two value.\n"},
  {"SetPolygonOffsetFactor", PyvtkShadowMapBakerPass_SetPolygonOffsetFactor, METH_VARARGS,
   "V.SetPolygonOffsetFactor(float)\nC++: virtual void SetPolygonOffsetFactor(float _arg)\n\nFactor used to scale the maximum depth slope of a polygon\n(definition from OpenGL 2.1 spec section 3.5.5 \"Depth Offset\"\npage 112). This is used during the creation the shadow maps (not\nduring mapping of the shadow maps onto the geometry) Play with\nthis value and PolygonOffsetUnits to solve self-shadowing. Valid\nvalues can be either positive or negative. Initial value is 1.1f\n(recommended by the nVidia presentation about Shadow Mapping by\nCass Everitt). 3.1f works well with the regression test.\n"},
  {"GetPolygonOffsetFactor", PyvtkShadowMapBakerPass_GetPolygonOffsetFactor, METH_VARARGS,
   "V.GetPolygonOffsetFactor() -> float\nC++: virtual float GetPolygonOffsetFactor()\n\nFactor used to scale the maximum depth slope of a polygon\n(definition from OpenGL 2.1 spec section 3.5.5 \"Depth Offset\"\npage 112). This is used during the creation the shadow maps (not\nduring mapping of the shadow maps onto the geometry) Play with\nthis value and PolygonOffsetUnits to solve self-shadowing. Valid\nvalues can be either positive or negative. Initial value is 1.1f\n(recommended by the nVidia presentation about Shadow Mapping by\nCass Everitt). 3.1f works well with the regression test.\n"},
  {"SetPolygonOffsetUnits", PyvtkShadowMapBakerPass_SetPolygonOffsetUnits, METH_VARARGS,
   "V.SetPolygonOffsetUnits(float)\nC++: virtual void SetPolygonOffsetUnits(float _arg)\n\nFactor used to scale an implementation dependent constant that\nrelates to the usable resolution of the depth buffer (definition\nfrom OpenGL 2.1 spec section 3.5.5 \"Depth Offset\" page 112). This\nis used during the creation the shadow maps (not during mapping\nof the shadow maps onto the geometry) Play with this value and\nPolygonOffsetFactor to solve self-shadowing. Valid values can be\neither positive or negative. Initial value is 4.0f (recommended\nby the nVidia presentation about Shadow Mapping by Cass Everitt).\n10.0f works well with the regression test.\n"},
  {"GetPolygonOffsetUnits", PyvtkShadowMapBakerPass_GetPolygonOffsetUnits, METH_VARARGS,
   "V.GetPolygonOffsetUnits() -> float\nC++: virtual float GetPolygonOffsetUnits()\n\nFactor used to scale an implementation dependent constant that\nrelates to the usable resolution of the depth buffer (definition\nfrom OpenGL 2.1 spec section 3.5.5 \"Depth Offset\" page 112). This\nis used during the creation the shadow maps (not during mapping\nof the shadow maps onto the geometry) Play with this value and\nPolygonOffsetFactor to solve self-shadowing. Valid values can be\neither positive or negative. Initial value is 4.0f (recommended\nby the nVidia presentation about Shadow Mapping by Cass Everitt).\n10.0f works well with the regression test.\n"},
  {"GetHasShadows", PyvtkShadowMapBakerPass_GetHasShadows, METH_VARARGS,
   "V.GetHasShadows() -> bool\nC++: bool GetHasShadows()\n\nINTERNAL USE ONLY. Internally used by vtkShadowMapBakerPass and\nvtkShadowMapPass.\n\n* Tell if there is at least one shadow.\n* Initial value is false.\n"},
  {"LightCreatesShadow", PyvtkShadowMapBakerPass_LightCreatesShadow, METH_VARARGS,
   "V.LightCreatesShadow(vtkLight) -> bool\nC++: bool LightCreatesShadow(vtkLight *l)\n\nINTERNAL USE ONLY. Internally used by vtkShadowMapBakerPass and\nvtkShadowMapPass.\n\n* Tell if the light `l' can create shadows.\n* The light has to not be a head light and to be directional or\n* positional with an angle less than 180 degrees.\n* \\pre l_exists: l!=0\n"},
  {"GetShadowMaps", PyvtkShadowMapBakerPass_GetShadowMaps, METH_VARARGS,
   "V.GetShadowMaps() -> vtkShadowMapBakerPassTextures\nC++: vtkShadowMapBakerPassTextures *GetShadowMaps()\n\nINTERNAL USE ONLY Internally used by vtkShadowMapBakerPass and\nvtkShadowMapPass.\n\n* Give access to the baked shadow maps.\n"},
  {"GetLightCameras", PyvtkShadowMapBakerPass_GetLightCameras, METH_VARARGS,
   "V.GetLightCameras() -> vtkShadowMapBakerPassLightCameras\nC++: vtkShadowMapBakerPassLightCameras *GetLightCameras()\n\nINTERNAL USE ONLY. Internally used by vtkShadowMapBakerPass and\nvtkShadowMapPass.\n\n* Give access the cameras builds from the ligths.\n"},
  {"GetNeedUpdate", PyvtkShadowMapBakerPass_GetNeedUpdate, METH_VARARGS,
   "V.GetNeedUpdate() -> bool\nC++: bool GetNeedUpdate()\n\nINTERNAL USE ONLY. Internally used by vtkShadowMapBakerPass and\nvtkShadowMapPass.\n\n* Do the shadows need to be updated?\n* Value changed by vtkShadowMapBakerPass and used by\n  vtkShadowMapPass.\n* Initial value is true.\n"},
  {"SetUpToDate", PyvtkShadowMapBakerPass_SetUpToDate, METH_VARARGS,
   "V.SetUpToDate()\nC++: void SetUpToDate()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkShadowMapBakerPass_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkShadowMapBakerPass", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkShadowMapBakerPass_StaticNew()
{
  return vtkShadowMapBakerPass::New();
}

PyObject *PyvtkShadowMapBakerPass_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkShadowMapBakerPass_Type, PyvtkShadowMapBakerPass_Methods,
    "vtkShadowMapBakerPass",
    PyvtkShadowMapBakerPass_Doc(), &PyvtkShadowMapBakerPass_StaticNew);

  PyTypeObject *pytype = &PyvtkShadowMapBakerPass_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRenderPass_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkShadowMapBakerPass_Doc()
{
  static const char *docstring[] = {
    "vtkShadowMapBakerPass - Implement a builder of shadow map pass.\n\n",
    "Superclass: vtkRenderPass\n\n",
    "Bake a list of shadow maps, once per spot light. It work in\nconjunction with the vtkShadowMapPass, which uses the shadow maps for\nrendering the opaque geometry (a technique to render hard shadows in\nhardware).\n\nThis pass expects an initialized depth buffer and color buffer.\nInitialized buffers means they have been cleared with farest z-value\nand background color/gradient/transparent color. An opaq",
    "ue pass may\nhave been performed right after the initialization.\n\nIts delegate is usually set to a vtkOpaquePass.\n\n@par Implementation: The first pass of the algorithm is to generate a\nshadow map per light (depth map from the light point of view) by\nrendering the opaque objects with the vtkShadowMapBakerPass::OCCLUDER\nproperty keys. The second pass is to render the opaque objects with\nthe vtkShadow",
    "Map::RECEIVER keys.\n\n@sa\nvtkRenderPass, vtkOpaquePass, vtkShadowMapPass\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkShadowMapBakerPass(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkShadowMapBakerPass_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkShadowMapBakerPass", o) != 0)
  {
    Py_DECREF(o);
  }

}

